package com.pmc.loganalysis.service.impl;

import ch.ethz.ssh2.Connection;
import com.pmc.loganalysis.config.multiple_data_sources.DataType;
import com.pmc.loganalysis.config.multiple_data_sources.DynamicDataSourceContextHolder;
import com.pmc.loganalysis.mapper.SmsPushsysMapper;
import com.pmc.loganalysis.service.SmsPushsysService;
import com.pmc.loganalysis.util.DateUtils;
import com.pmc.loganalysis.util.shell.ExecShell;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * <p>
 * 字典表 服务实现类
 * </p>
 */
@Service
@Slf4j
public class SmsPushsysServiceImpl implements SmsPushsysService {
    @Value("${shell.shell-path1}")
    private String shellPath;
    @Value("${shell.log-path1}")
    private String logPath;
    @Resource
    private SmsPushsysMapper smsPushsysMapper;
    /**
     * 服务器
     * @param startTimeStr 开始时间
     * @param endTimeStr 结束时间

     * @return
     */
    @Override
    public String pushTravelCardByMinRate(String startTime, String endTime,String startTimeStr, String endTimeStr,String tjflag, String startTimeStri){
        DynamicDataSourceContextHolder.setDataSourceKey(DataType.MASTER);
        String logPath1 ="";
        if( StringUtils.isBlank(shellPath) ){
            return "配置脚本信息有误";
        }
       // pCode = CryptoEncoder.base64Decode(pCode);
        if("00".equals(tjflag)){
            logPath ="/opt/pmc/envoy/envoy-in/logs/envoy-in.txt."+startTimeStri;
            logPath1 ="/opt/pmc/envoy/envoy-in/logs/envoy-in.txt";
        }else{
            logPath ="/opt/pmc/envoy/envoy-in/logs/envoy-in.txt";
        }
        List<String> commandList1 = this.getCommandList(startTimeStr,endTimeStr,shellPath,logPath);
        String finalCommand = "";
        for(String str : commandList1){
            finalCommand = finalCommand + str + " && ";
        }
       finalCommand = finalCommand.substring(0,finalCommand.length()-4);
       // Connection conn = ExecShell.login(ip, user, pass);
        //多条命令可以用&&分割
        //String cmd = "cd /home/&&pwd&&ls";
        //String result = ExecShell.execute(conn,finalCommand);
        String result = ExecShell.executes(finalCommand);
        if(result==null||"".equals(result)){
            result="0";
        }
        String result2 ="";
        if("00".equals(tjflag)){
            List<String> commandList2 = this.getCommandList(startTimeStr,endTimeStr,shellPath,logPath1);
            String finalCommand2 = "";
            for(String str : commandList2){
                finalCommand2 = finalCommand2 + str + " && ";
            }
            finalCommand2 = finalCommand2.substring(0,finalCommand2.length()-4);
             result2 = ExecShell.executes(finalCommand2);
            if(result2==null||"".equals(result2)){
                result2="0";
            }
        }
        if(!"0".equals(result2)&&!"".equals(result2)){
            Integer result1 =Integer.valueOf(result)+Integer.valueOf(result2);
            result =result1.toString();
        }

        Date nowDate = new Date ();
        //获取当前时间的前一分钟
        String createTime   = DateUtils.getDateStringYMDHMS(nowDate,DateUtils.DATE_TIME_PATTERN_YYYYMMDDHHMMSSSSS);
        smsPushsysMapper.insertXCKProStatisEnvoyMin(UUID.randomUUID().toString(),endTime,result,createTime);
        log.info("统计envoy日志时间："+startTimeStr+"----"+endTimeStr+"的请求总数："+result+"====>入库时间："+endTime);

        return result;
    }

    /**
     * 连接服务器，执行shell
     * @param startTimeStr 开始时间
     * @param endTimeStr 结束时间
     * @param path shell路径
     * @param logPath 日志文件路径
     * @return
     */
    private List<String> getCommandList(String startTimeStr, String endTimeStr, String path,String logPath){
        List<String> commandStrList = new ArrayList<>();
        try {
            // /usr/test/test.sh "09/Jul/2021:03:33:00" "09/Jul/2021:03:40:00' /opt/file/access-2021-10-13-11.log access.log
            Date date = DateUtils.getDateByString(startTimeStr, DateUtils.DATE_YYYYMMDDHHMMSS);
            SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd'T'HH:mm:ss");
            String startTime = formatter.format(date);
            Date date2 = DateUtils.getDateByString(endTimeStr, DateUtils.DATE_YYYYMMDDHHMMSS);
            String endTime = formatter.format(date2);
           // String timePath =  "/app/XCK/getEnvoy.sh 2022-10-28T20:55:00.419 2022-10-28T20:59:48.419Z  ";
            String timePath = path+"  "+startTime+"  "+endTime+"  ";

            String command = timePath + logPath ;
            log.info("统计数据命令："+command);
            commandStrList.add(command);

        }catch (Exception e) {
            e.printStackTrace();
        }
        return commandStrList;
    }

}
