package com.pmc.loganalysis.task;

import com.pmc.loganalysis.service.SmsPushsysService;
import com.pmc.loganalysis.util.DateUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.scheduling.annotation.EnableAsync;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.Date;

/**
 * 定时任务
 * @description 
 */
@EnableAsync
@Component
@EnableScheduling
@Slf4j
public class FiveIndexMonitorTask {


    @Value("${before-minute}")
    Integer beforeminutes;
    @Value("${before-end-minute}")
    Integer beforeendminutes;

    @Value("${input-minute}")
    Integer inputminute;

    @Resource
    SmsPushsysService smsPushsysService;

    /**
     * 定时统计当前时间之前一分钟内的数据统计
     */
    @Scheduled(cron = "${springTiming.monitor1-min-time}")
    public void StatisticsTravelCardDaily() {
        String flag="1";
        //获取现在时间（开始时间）
        Date nowDate = new Date ();
        //获取当前时间的前一分钟
        Date startDate = DateUtils.getDate(nowDate,beforeminutes);
        String startTime   = DateUtils.getDateStringYMDHMS(startDate,DateUtils.DATE_TIME_PATTERN);
        String startTimeStri   = DateUtils.getDateStringYMDHMS(startDate,DateUtils.DATE_YYYYMMDD);
        String startTimestr   = DateUtils.getDateStringYMDHMS(startDate,DateUtils.DATE_YYYYMMDDHHMMSS);
        Date endDate = DateUtils.getDate(nowDate,beforeendminutes);
        Date endDates = DateUtils.getDate(nowDate,inputminute);
        String endTime = DateUtils.getDateStringYMDHMS(endDates,DateUtils.DATE_TIME_PATTERNS);
        String endTimestr = DateUtils.getDateStringYMDHMS(endDate,DateUtils.DATE_YYYYMMDDHHMMSS);
        //获取当前时间，进行判断是否当前时间是00:00:00或者00:01:00
        String startDateNewstr = DateUtils.getDateStringYMDHMS(nowDate,DateUtils.DATE_YYYYMMDDHHMMSS);
        String endTimeStrs = startDateNewstr.substring(startDateNewstr.length()-6);
        if("000000".equals(endTimeStrs)||"000100".equals(endTimeStrs)) {
            flag ="00";
        }

        smsPushsysService.pushTravelCardByMinRate(startTime,endTime,startTimestr,endTimestr,flag,startTimeStri);
    }





}

